//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <stdio.h>
#pragma hdrstop

#include "train.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
int spr_size=16;
unsigned int *tabspr1,*tabspr2;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
if(OpenPictureDialog1->Execute())
{
    Image1->Picture->LoadFromFile(OpenPictureDialog1->FileName);
    Label4->Caption=IntToStr(Image1->Width);
    Label5->Caption=IntToStr(Image1->Height);
}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
if(OpenPictureDialog2->Execute())
{
    Image2->Picture->LoadFromFile(OpenPictureDialog2->FileName);
    Label7->Caption=IntToStr(Image2->Width);
    Label8->Caption=IntToStr(Image2->Height);
}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{

if(OpenPictureDialog3->Execute())
{
    Image3->Picture->LoadFromFile(OpenPictureDialog3->FileName);
    Label15->Caption=IntToStr(Image3->Width);
    Label16->Caption=IntToStr(Image3->Height);
}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
 exit(0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
   for(int x=0;x<Image1->Width;x++)
      for(int y=0;y<Image1->Height;y++)
         if(Image1->Canvas->Pixels[x][y]!=Image3->Canvas->Pixels[x][y])
         {
            CGauge1->Progress=((x*100)/Image1->Width);
            Image1->Canvas->Pixels[x][y]=clFuchsia;
            }
   CGauge1->Progress=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
   TColor col;
   int pwr;
   for(int x=0;x<Image1->Width;x++)
      for(int y=0;y<Image1->Height;y++)
      {
         col=Image1->Canvas->Pixels[x][y];
         if(col!=clFuchsia)
         {
          pwr=(col&0x000000ff)+((col&0x0000ff00)/256)+(col&0x00ff0000)/(256*256);
         if(pwr<CSpinEdit1->Value)
            Image1->Canvas->Pixels[x][y]=clBlack;
         if(pwr>=CSpinEdit1->Value&&pwr<CSpinEdit2->Value)
            Image1->Canvas->Pixels[x][y]=clGray;
         if(pwr>=CSpinEdit2->Value&&pwr<CSpinEdit3->Value)
            Image1->Canvas->Pixels[x][y]=clSilver;
         if(pwr>=CSpinEdit3->Value)
            Image1->Canvas->Pixels[x][y]=clWhite;
         }
         col=Image2->Canvas->Pixels[x][y];
         pwr=(col&0x000000ff)+((col&0x0000ff00)/256)+(col&0x00ff0000)/(256*256);
         if(pwr<CSpinEdit1->Value)
            Image2->Canvas->Pixels[x][y]=clBlack;
         if(pwr>=CSpinEdit1->Value&&pwr<CSpinEdit2->Value)
            Image2->Canvas->Pixels[x][y]=clGray;
         if(pwr>=CSpinEdit2->Value&&pwr<CSpinEdit3->Value)
            Image2->Canvas->Pixels[x][y]=clSilver;
         if(pwr>=CSpinEdit3->Value)
            Image2->Canvas->Pixels[x][y]=clWhite;
         CGauge1->Progress=((x*100)/Image1->Width);
       }
   CGauge1->Progress=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
   TColor col;
      for(int x=0;x<Image1->Width;x++)
      for(int y=0;y<Image1->Height;y++)
      {
         col=Image1->Canvas->Pixels[x][y];
        if(RadioButton5->Checked==true)
        {
            if(col==clBlack)
                Image1->Canvas->Pixels[x][y]=clGray;
            else if(col==clFuchsia)
                Image1->Canvas->Pixels[x][y]=clBlack;
        }
        else if(RadioButton4->Checked==true)
        {
            if(col==clWhite)
                Image1->Canvas->Pixels[x][y]=clSilver;
            else if(col==clFuchsia)
                Image1->Canvas->Pixels[x][y]=clWhite;
        }


      CGauge1->Progress=((x*100)/Image1->Width);
      }
   CGauge1->Progress=0;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
      for(int x=0;x<Image1->Width;x++)
      for(int y=0;y<Image1->Height;y++)
      {
         Image3->Canvas->Pixels[x][y]=Image2->Canvas->Pixels[x][y];

         if((Image1->Canvas->Pixels[x][y]!=clBlack)&&(RadioButton5->Checked==true))
                 Image3->Canvas->Pixels[x][y]=Image1->Canvas->Pixels[x][y];
         if((Image1->Canvas->Pixels[x][y]!=clWhite)&&(RadioButton4->Checked==true))
                 Image3->Canvas->Pixels[x][y]=Image1->Canvas->Pixels[x][y];
      CGauge1->Progress=((x*100)/Image1->Width);
      }
   CGauge1->Progress=0;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::SpeedButton9Click(TObject *Sender)
{
int same[4],nbtotspr,presentspr;

tabspr1=(unsigned int*)malloc((Image1->Width/spr_size)*(Image1->Height/spr_size)*sizeof(unsigned int));

nbtotspr=0;
Image5->Width=1023*16;
Image5->Height=32;
Image8->Width=102*20;
Image8->Height=102*20;
Image8->Canvas->FillRect(Rect(0,0,102*20-1,102*20-1));

for(int x=0;x<Image1->Width/spr_size;x++)
    for(int y=0;y<Image1->Height/spr_size;y++)
    {
        presentspr=0;
        for(int nbsprites=0;nbsprites<nbtotspr;nbsprites++)
        {
            for(int sameinit=0;sameinit<4;sameinit++)
                same[sameinit]=1;
            for(int xpos=0;xpos<spr_size;xpos++)
                for(int ypos=0;ypos<spr_size;ypos++)
                {
                    if(Image1->Canvas->Pixels[xpos+x*spr_size][ypos+y*spr_size]
                    !=Image5->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                        same[0]=0;
                    if(CheckBox3->Checked==true)
                    {
                        if(Image1->Canvas->Pixels[spr_size-1-xpos+x*spr_size][ypos+y*spr_size]
                        !=Image5->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                            same[1]=0;
                        if(Image1->Canvas->Pixels[xpos+x*spr_size][spr_size-1-ypos+y*spr_size]
                        !=Image5->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                            same[2]=0;
                        if(Image1->Canvas->Pixels[spr_size-1-xpos+x*spr_size][spr_size-1-ypos+y*spr_size]
                        !=Image5->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                            same[3]=0;
                    }
                }
            if(same[0])
            {
                presentspr=1;
                tabspr1[x+y*(Image1->Width/spr_size)]=nbsprites;
                Image8->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                nbsprites=nbtotspr;
            }
            else if(same[1]&&CheckBox3->Checked)
            {
                presentspr=1;
                tabspr1[x+y*(Image1->Width/spr_size)]=nbsprites+2048;
                Image8->Canvas->Font->Color=clRed;
                Image8->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                Image8->Canvas->Font->Color=clBlack;
                nbsprites=nbtotspr;
            }
            else if(same[2]&&CheckBox3->Checked)
            {
                presentspr=1;
                tabspr1[x+y*(Image1->Width/spr_size)]=nbsprites+1024;
                Image8->Canvas->Font->Color=clBlue;
                Image8->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                Image8->Canvas->Font->Color=clBlack;
                nbsprites=nbtotspr;
            }
            else if(same[3]&&CheckBox3->Checked)
            {
                presentspr=1;
                tabspr1[x+y*(Image1->Width/spr_size)]=nbsprites+3072;
                Image8->Canvas->Font->Color=clGreen;
                Image8->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                Image8->Canvas->Font->Color=clBlack;
                nbsprites=nbtotspr;
            }
        }
        if(presentspr==0)
        {
        tabspr1[x+y*(Image1->Width/spr_size)]=nbtotspr;
        Image8->Canvas->TextOut(20*x,20*y,IntToStr(nbtotspr));
        for(int xpos=0;xpos<spr_size;xpos++)
            for(int ypos=0;ypos<spr_size;ypos++)
                Image5->Canvas->Pixels[nbtotspr*spr_size+xpos][ypos]
                =Image1->Canvas->Pixels[xpos+x*spr_size][ypos+y*spr_size];
        nbtotspr=nbtotspr+1;
        }
        CGauge1->Progress=((x*50)/(Image1->Width/spr_size));
    }
    Image5->Width=nbtotspr*spr_size;
    Image5->Height=spr_size;
    Image8->Width=20*(Image1->Width/spr_size);
    Image8->Height=20*(Image1->Height/spr_size);
    Label23->Caption=IntToStr(nbtotspr);
    CGauge1->Progress=50;

tabspr2=(unsigned int*)malloc((Image2->Width/spr_size)*(Image2->Height/spr_size)*sizeof(unsigned int));

nbtotspr=0;
Image6->Width=1023*16;
Image6->Height=32;
Image9->Width=102*20;
Image9->Height=102*20;
Image9->Canvas->FillRect(Rect(0,0,Image2->Width-1,Image2->Height-1));

for(int x=0;x<Image2->Width/spr_size;x++)
    for(int y=0;y<Image2->Height/spr_size;y++)
    {
        presentspr=0;
        for(int nbsprites=0;nbsprites<nbtotspr;nbsprites++)
        {
            for(int sameinit=0;sameinit<4;sameinit++)
                same[sameinit]=1;
            for(int xpos=0;xpos<spr_size;xpos++)
                for(int ypos=0;ypos<spr_size;ypos++)
                {
                    if(Image2->Canvas->Pixels[xpos+x*spr_size][ypos+y*spr_size]
                    !=Image6->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                        same[0]=0;
                    if(CheckBox3->Checked==true)
                    {
                        if(Image2->Canvas->Pixels[spr_size-1-xpos+x*spr_size][ypos+y*spr_size]
                        !=Image6->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                            same[1]=0;
                        if(Image2->Canvas->Pixels[xpos+x*spr_size][spr_size-1-ypos+y*spr_size]
                        !=Image6->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                            same[2]=0;
                        if(Image2->Canvas->Pixels[spr_size-1-xpos+x*spr_size][spr_size-1-ypos+y*spr_size]
                        !=Image6->Canvas->Pixels[nbsprites*spr_size+xpos][ypos])
                            same[3]=0;
                    }
                }
            if(same[0])
            {
                presentspr=1;
                tabspr2[x+y*(Image1->Width/spr_size)]=nbsprites;
                Image9->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                nbsprites=nbtotspr;
            }
            else if(same[1]&&CheckBox3->Checked)
            {
                presentspr=1;
                tabspr2[x+y*(Image1->Width/spr_size)]=nbsprites+2048;
                Image9->Canvas->Font->Color=clRed;
                Image9->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                Image9->Canvas->Font->Color=clBlack;
                nbsprites=nbtotspr;
            }
            else if(same[2]&&CheckBox3->Checked)
            {
                presentspr=1;
                tabspr2[x+y*(Image1->Width/spr_size)]=nbsprites+1024;
                Image9->Canvas->Font->Color=clBlue;
                Image9->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                Image9->Canvas->Font->Color=clBlack;
                nbsprites=nbtotspr;
            }
            else if(same[3]&&CheckBox3->Checked)
            {
                presentspr=1;
                tabspr2[x+y*(Image1->Width/spr_size)]=nbsprites+3072;
                Image9->Canvas->Font->Color=clGreen;
                Image9->Canvas->TextOut(20*x,20*y,IntToStr(nbsprites));
                Image9->Canvas->Font->Color=clBlack;
                nbsprites=nbtotspr;
            }
        }
        if(presentspr==0)
        {
        tabspr2[x+y*(Image1->Width/spr_size)]=nbtotspr;
        Image9->Canvas->TextOut(20*x,20*y,IntToStr(nbtotspr));
        for(int xpos=0;xpos<spr_size;xpos++)
            for(int ypos=0;ypos<spr_size;ypos++)
                Image6->Canvas->Pixels[nbtotspr*spr_size+xpos][ypos]
                =Image2->Canvas->Pixels[xpos+x*spr_size][ypos+y*spr_size];
        nbtotspr=nbtotspr+1;
        }
        CGauge1->Progress=((x*50)/(Image1->Width/spr_size))+50;
    }
    Image6->Width=nbtotspr*spr_size;
    Image6->Height=spr_size;
    Image9->Width=20*(Image2->Width/spr_size);
    Image9->Height=20*(Image2->Height/spr_size);
    Label26->Caption=IntToStr(nbtotspr);
    CGauge1->Progress=0;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton10Click(TObject *Sender)
{
        unsigned int sprite_number;
        int x_map_spr,y_map_spr,temp_map_spr;
        TColor color;
        FILE *filesave;
        char filename[15],message[1000],tabtemp;

       Edit6->GetTextBuf(message,Edit6->GetTextLen()+1);
       sprintf(filename,"%s1.lvl",message);
       filesave=fopen(filename,"wb");
	for(int y_sprite=0;y_sprite<Image1->Height/spr_size;y_sprite++) {
		for(int x_sprite=0;x_sprite<Image1->Width/spr_size;x_sprite++) {
                        tabtemp=(char)tabspr1[x_sprite+y_sprite*(Image1->Width/spr_size)];
                        fputc(tabtemp,filesave);
                        tabtemp=(char)(tabspr1[x_sprite+y_sprite*(Image1->Width/spr_size)]>>8);
                        fputc(tabtemp,filesave);
                        }
		}
       fclose(filesave);

       Edit6->GetTextBuf(message,Edit6->GetTextLen()+1);
       sprintf(filename,"%s2.lvl",message);

       filesave=fopen(filename,"wb");
	for(int y_sprite=0;y_sprite<Image2->Height/spr_size;y_sprite++) {
		for(int x_sprite=0;x_sprite<Image2->Width/spr_size;x_sprite++) {
                        tabtemp=(char)tabspr2[x_sprite+y_sprite*(Image2->Width/spr_size)];
                        fputc(tabtemp,filesave);
                        tabtemp=(char)(tabspr2[x_sprite+y_sprite*(Image2->Width/spr_size)]>>8);
                        fputc(tabtemp,filesave);
			}
		}
       fclose(filesave);

       Edit6->GetTextBuf(message,Edit6->GetTextLen()+1);
       sprintf(filename,"%s1.bin",message);
       filesave=fopen(filename,"wb");

	for(int sprite_scan=0;sprite_scan<StrToInt(Label23->Caption);sprite_scan++) {
        	for(int y_sprite=0;y_sprite<spr_size;y_sprite++) {
	        	x_map_spr=0;
			y_map_spr=0;
			for(int x_sprite=0;x_sprite<spr_size;x_sprite++) {
				color=Image5->Canvas->Pixels[x_sprite+sprite_scan*spr_size][y_sprite];
				if(color==clBlack) {
					x_map_spr=x_map_spr<<1;
					x_map_spr=x_map_spr++;
					y_map_spr=y_map_spr<<1;
					y_map_spr=y_map_spr++;
				} else if(color==clGray) {
					x_map_spr=x_map_spr<<1;
					x_map_spr=x_map_spr++;
					y_map_spr=y_map_spr<<1;
				} else if(color==clSilver) {
					x_map_spr=x_map_spr<<1;
					y_map_spr=y_map_spr<<1;
					y_map_spr=y_map_spr++;
				} else {
					x_map_spr=x_map_spr<<1;
					y_map_spr=y_map_spr<<1;
				}
			}
			temp_map_spr=x_map_spr>>8;
			fputc((char)temp_map_spr,filesave);
			fputc((char)x_map_spr,filesave);
			temp_map_spr=y_map_spr>>8;
			fputc((char)temp_map_spr,filesave);
			fputc((char)y_map_spr,filesave);
		}
       	}

        fclose(filesave);

       Edit6->GetTextBuf(message,Edit6->GetTextLen()+1);
       sprintf(filename,"%s2.bin",message);
       filesave=fopen(filename,"wb");

	for(int sprite_scan=0;sprite_scan<StrToInt(Label26->Caption);sprite_scan++) {
        	for(int y_sprite=0;y_sprite<spr_size;y_sprite++) {
	        	x_map_spr=0;
			y_map_spr=0;
			for(int x_sprite=0;x_sprite<spr_size;x_sprite++) {
				color=Image6->Canvas->Pixels[x_sprite+sprite_scan*spr_size][y_sprite];
				if(color==clBlack) {
					x_map_spr=x_map_spr<<1;
					x_map_spr=x_map_spr++;
					y_map_spr=y_map_spr<<1;
					y_map_spr=y_map_spr++;
				} else if(color==clGray) {
					x_map_spr=x_map_spr<<1;
					x_map_spr=x_map_spr++;
					y_map_spr=y_map_spr<<1;
				} else if(color==clSilver) {
					x_map_spr=x_map_spr<<1;
					y_map_spr=y_map_spr<<1;
					y_map_spr=y_map_spr++;
				} else {
					x_map_spr=x_map_spr<<1;
					y_map_spr=y_map_spr<<1;
				}
			}
			temp_map_spr=x_map_spr>>8;
			fputc((char)temp_map_spr,filesave);
			fputc((char)x_map_spr,filesave);
			temp_map_spr=y_map_spr>>8;
			fputc((char)temp_map_spr,filesave);
			fputc((char)y_map_spr,filesave);
		}
       	}

        fclose(filesave);

       sprintf(message,"Les fichiers ont t enregistrs avec l'image : %s",OpenPictureDialog1->FileName);
       ShowMessage(message);
}
//---------------------------------------------------------------------------




void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
      for(int x=0;x<Image1->Width;x++)
      for(int y=0;y<Image1->Height;y++)
      {
         if(Image2->Canvas->Pixels[x][y]==clBlack)
                Image3->Canvas->Pixels[x][y]=0x008A6F53;
         else if(Image2->Canvas->Pixels[x][y]==clGray)
                Image3->Canvas->Pixels[x][y]=0x00958C6F;
         else if(Image2->Canvas->Pixels[x][y]==clSilver)
                Image3->Canvas->Pixels[x][y]=0x00A1A98B;
         else if(Image2->Canvas->Pixels[x][y]==clWhite)
                Image3->Canvas->Pixels[x][y]=0x00ADC6A8;

         if((Image1->Canvas->Pixels[x][y]==clWhite)&&(RadioButton5->Checked==true))
                Image3->Canvas->Pixels[x][y]=0x00ADC6A8;
         else if(Image1->Canvas->Pixels[x][y]==clSilver)
                Image3->Canvas->Pixels[x][y]=0x00A1A98B;
         else if(Image1->Canvas->Pixels[x][y]==clGray)
                Image3->Canvas->Pixels[x][y]=0x00958C6F;
         else if((Image1->Canvas->Pixels[x][y]==clBlack)&&(RadioButton4->Checked==true))
                Image3->Canvas->Pixels[x][y]=0x008A6F53;
      CGauge1->Progress=((x*100)/Image1->Width);
      }
   CGauge1->Progress=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton11Click(TObject *Sender)
{
      for(int x=0;x<Image1->Width;x++)
      for(int y=0;y<Image1->Height;y++)
      {
         if(Image2->Canvas->Pixels[x][y]==clBlack)
                Image3->Canvas->Pixels[x][y]=0x00222E31;
         else if(Image2->Canvas->Pixels[x][y]==clGray)
                Image3->Canvas->Pixels[x][y]=0x005B6964;
         else if(Image2->Canvas->Pixels[x][y]==clSilver)
                Image3->Canvas->Pixels[x][y]=0x0095A498;
         else if(Image2->Canvas->Pixels[x][y]==clWhite)
                Image3->Canvas->Pixels[x][y]=0x00CFE0CC;

         if((Image1->Canvas->Pixels[x][y]==clWhite)&&(RadioButton5->Checked==true))
                Image3->Canvas->Pixels[x][y]=0x00CFE0CC;
         else if(Image1->Canvas->Pixels[x][y]==clSilver)
                Image3->Canvas->Pixels[x][y]=0x0095A498;
         else if(Image1->Canvas->Pixels[x][y]==clGray)
                Image3->Canvas->Pixels[x][y]=0x005B6964;
         else if((Image1->Canvas->Pixels[x][y]==clBlack)&&(RadioButton4->Checked==true))
                Image3->Canvas->Pixels[x][y]=0x00222E31;


      CGauge1->Progress=((x*100)/Image1->Width);
      }
   CGauge1->Progress=0;
}
//---------------------------------------------------------------------------





void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
spr_size=8;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
spr_size=16;        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
spr_size=32;        
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
       free(tabspr1);
       free(tabspr2);        
}
//---------------------------------------------------------------------------

